package com.muyu.common.system.remote.factory;

import com.muyu.common.core.domain.Result;
import com.muyu.common.system.domain.EntInfo;
import com.muyu.common.system.remote.RemoteNetworkingService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 用户服务降级处理
 *
 * @author muyu
 */
@Component
public class RemoteUserFallbackFactory implements FallbackFactory<RemoteNetworkingService> {
    private static final Logger log = LoggerFactory.getLogger(RemoteUserFallbackFactory.class);

    @Override
    public RemoteNetworkingService create (Throwable throwable) {
        log.error("用户服务调用失败:{}", throwable.getMessage());
        return new RemoteNetworkingService() {

            @Override
            public Result<List<EntInfo>> list() {
                return Result.error("获取用户失败:{}");
            }
        };
    }
}
