package com.muyu.networking.controller;




import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.muyu.common.core.domain.Result;
import com.muyu.domain.data.VehicleData;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.*;

/**
 * @ClassDescription:
 * @JdkVersion: 17
 * @Author: zhangxu
 * @Created: 2024/6/18 15:51
 */
@Log4j2
@RestController
@RequestMapping("/vehicleData")
public class VehicleDataController {

    @Autowired
    private RedisTemplate<String,String> redisTemplate;


    @GetMapping("vehicleData/{vin}")
    public Result<VehicleData> list(@PathVariable String vin) {
        String index = redisTemplate.opsForList().index(vin, -1);
        log.info("数据{}",index);
        VehicleData vehicleData = JSONObject.parseObject(index, VehicleData.class);
        log.info("输出数据{}",index);

//
        return Result.success(vehicleData);


    }



}
