package com.muyu.networking.service.impl;








import com.alibaba.fastjson.JSON;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.DateUtils;
import com.muyu.common.security.utils.SecurityUtils;
import com.muyu.common.system.domain.LoginUser;
import com.muyu.common.system.domain.SysRole;
import com.muyu.common.system.domain.SysUser;
import com.muyu.common.system.remote.RemoteUserService;
import com.muyu.domain.Enterprise;

import com.muyu.domain.datasources.Datasource;

import com.muyu.networking.mapper.EnterpriseMapper;
import com.muyu.networking.service.EnterpriseService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.IllegalFormatCodePointException;
import java.util.List;
import java.util.UUID;


/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2024-05-25
 */
@Service
@DS("networking")
@Log4j2
public class EnterpriseServiceImpl  extends ServiceImpl<EnterpriseMapper,Enterprise> implements EnterpriseService
{

    @Autowired
    private RemoteUserService remoteUserService;

    @Autowired(required = false)
    private EnterpriseMapper enterpriseMapper;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override
    public Enterprise selectEnterpriseById(Long id)
    {
        return enterpriseMapper.selectEnterpriseById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     *
     * @param enterprise 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<Enterprise> selectEnterpriseList(Enterprise enterprise)
    {

        if (SecurityUtils.isAdmin(SecurityUtils.getUserId())) {
            return enterpriseMapper.selectEnterpriseList(enterprise);
        }
        SysUser sysUser = SysUser.builder().userName(SecurityUtils.getUsername()).build();
        //判断 不是管理员登录 自能看自己的企业
        LambdaQueryWrapper<Enterprise> lambdaQueryWrapper = new LambdaQueryWrapper<>(){{
            eq(Enterprise::getEnterpriseName, sysUser.getUserName());
        }};
//
        return enterpriseMapper.selectList(lambdaQueryWrapper);
    }



    /**
     * 新增【请填写功能名称】
     *
     * @param enterprise 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int insertEnterprise(Enterprise enterprise)
    {
        enterprise.setCreateBy(SecurityUtils.getUsername());
        enterprise.setCreateTime(DateUtils.getNowDate());
        enterprise.setBusinessLicenseNumber(UUID.randomUUID().toString().replaceAll("-",""));
        enterprise.setStatus("1");
        enterprise.setCertification("0");
        enterprise.setOpenAdd("0");
        SysUser sysUser = SysUser.builder().userName(
                enterprise.getEnterpriseName())
                .password("admin")
                .entId(enterprise.getId())
                .roleId(2L)
                .nickName(enterprise.getEnterpriseName()).
                userType(String.valueOf(enterprise.getId()))
                .build();
        Result add = remoteUserService.add(sysUser);
        return   enterpriseMapper.insertEnterprise(enterprise);
    }
    /**
     * 修改【请填写功能名称】
     *
     * @param enterprise 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateEnterprise(Enterprise enterprise)
    {
        enterprise.setUpdateTime(DateUtils.getNowDate());
        int i = enterpriseMapper.updateEnterprise(enterprise);
        if (i>0){
            initialize(enterprise);
        }else {
            log.info("修改失败");
        }
        return i;
    }

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteEnterpriseByIds(Long[] ids)
    {
        return enterpriseMapper.deleteEnterpriseByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteEnterpriseById(Long id)
    {
        return enterpriseMapper.deleteEnterpriseById(id);
    }

    @Override
    public int updateEnterpriseStatus(Long id, String openAdd) {
        if (enterpriseMapper.updateEnterpriseStatus(id, openAdd) > 0) {
            return 1;
        }
        return 0;
    }

    public void initialize(Enterprise enterprise)
    {
        String postUrl="jiangmu";
        HashMap<String, String> hashMap = new HashMap<>();
        String contactPhone = enterprise.getContactPhone();
        String phone=contactPhone.substring(contactPhone.length()-4);
        String entId ="ent_id"+enterprise.getId();
        hashMap.put("entId",entId);
        long port=3306+enterprise.getId();
        hashMap.put("mysqlPort",String.valueOf(port));
        //创建连接与设置连接参数
        URL url = null;
        try {
             url = new URL(postUrl);
            HttpURLConnection httpConn = (HttpURLConnection) url.openConnection();
            httpConn.setRequestMethod("POST");
            httpConn.setRequestProperty("Charset","UTF-8");
            //POST 请求JSON 数据，必须设置
            httpConn.setRequestProperty("Content-Type","application/json");
            //默认代开是ture
            httpConn.setDoOutput(true);
            //从HTTPUrLConnection 获取输入流
            OutputStream outputStream = httpConn.getOutputStream();
            outputStream.write(JSON.toJSONString(hashMap).getBytes());
            outputStream.flush();
            //发起Http调用
            if (httpConn.getResponseCode()!= 200){
                throw new RuntimeException("请求失败");
            }
            BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(httpConn.getInputStream()));
            String s = bufferedReader.readLine();
            log.info("从服务端返回结果{}",s);
            httpConn.disconnect();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }


    }














//public void DockerMySQLExample() throws IOException {
//        //配置docker 客户端配置
//    DefaultDockerClientConfig.createDefaultConfigBuilder()
//            .withDockerHost("tcp://115.159.67.205:3306") // 使用Docker守护进程地址
//            .build();
//    DockerClient dockerClient = DockerClientBuilder.getInstance().build();
//
//    try {
//        CreateContainerCmd createContainerCmd = dockerClient.createContainerCmd("mysql:latest")
//                .withName("my-mysql-container")
//                .withEnv("MYSQL_ROOT_PASSWORD=my-secret-pw");
//        CreateContainerResponse container = createContainerCmd.exec();
//        System.out.println("Created container " + container.getId());
//        dockerClient.startContainerCmd(container.getId()).exec();
//        InspectContainerResponse inspectContainerResponse = dockerClient.inspectContainerCmd(container.getId()).exec();
//        System.out.println("Started container " + container.getId());
//        System.out.println("Container started, inspecting logs:");
//        InputStream logs = dockerClient.logContainerCmd(container.getId())
//                .withStdErr(true)
//                .withStdOut(true)
//                .withFollowStream(true)
//                .exec();
//        try (BufferedReader reader = new BufferedReader(new InputStreamReader(logs))) {
//            String line;
//            while ((line = reader.readLine()) != null) {
//                System.out.println(line);
//            }
//        }
//        ExecCreateCmdResponse execCreateCmdResponse = dockerClient.execCreateCmd(container.getId())
//                .withCmd("mysql", "-u", "root", "-p", "my-secret-pw", "my_database")
//                .exec();
//    }
//    catch (Exception e) {
//        e.printStackTrace();
//    }
//    dockerClient.close();
//}








//    public void DockerMySQLExample() throws IOException {
//            // 配置Docker客户端
//            DefaultDockerClientConfig config = DefaultDockerClientConfig.createDefaultConfigBuilder()
//                    .withDockerHost("tcp://115.159.67.205:3306") // 使用Docker守护进程地址
//                    .build();
//            DockerClient dockerClient = DockerClientBuilder.getInstance(config).build();
//
//            try {
//                // 创建新的MySQL容器
//                CreateContainerCmd createContainerCmd = dockerClient.createContainerCmd("mysql:latest")
//                        .withName("my-mysql-container")
//                        .withEnv("MYSQL_ROOT_PASSWORD=my-secret-pw");
//
//                CreateContainerResponse container = createContainerCmd.exec();
//                System.out.println("Created container " + container.getId());
//
//                // 启动MySQL容器
//                dockerClient.startContainerCmd(container.getId()).exec();
//
//                // 执行初始化脚本
//                String initScript = "CREATE DATABASE IF NOT EXISTS mydb;\n" +
//                        "GRANT ALL PRIVILEGES ON mydb.* TO 'myuser' IDENTIFIED BY 'mypass';";
//
//                // 获取容器的进程信息
//                InspectContainerResponse inspectContainerResponse = dockerClient.inspectContainerCmd(container.getId()).exec();
//                String containerId = inspectContainerResponse.getId();
//
//                // 将初始化脚本通过stdin传递给MySQL
//                String execId = dockerClient.execCreateCmd(containerId, "/bin/bash", "-c", "mysql -u root -p$MYSQL_ROOT_PASSWORD")
//                        .withAttachStdout(true)
//                        .withAttachStdin(true)
//                        .exec()
//                        .getId();
//
//                try (ExecStartResultCallback callback = new ExecStartResultCallback()) {
//
//                    InputStream execStream = dockerClient.execStartCmd(execId).withDetach(false)
//                            .withTty(false)
//                            .withCmd(initScript)
//                            .exec()
//                            .getExecResult()
//                            .getStdout();
//
//                    // 读取并打印脚本执行结果
//                    BufferedReader reader = new BufferedReader(new InputStreamReader(execStream));
//                    String line;
//                    while ((line = reader.readLine()) != null) {
//                        System.out.println(line);
//                    }
//                }
//            } catch (Exception e) {
//                e.printStackTrace();
//            } finally {
//                // 清理资源，移除容器
//                dockerClient.close();
//            }
//        }

    }


